import glob from 'glob';
import gulp from 'gulp';
import replace from 'gulp-replace';
import conf from './conf';

export function setPaths (done) {
    return glob(`wp-content/themes/${conf.name}/+(css|js)/**/*.min.+(css|js)`, {}, (er, files) => {
        if (er) {
            console.dir(er);
            return done;
        }

        let stream = gulp.src([`wp-content/themes/${conf.name}/+(footer|header)+(*).php`], { base: `wp-content/themes/${conf.name}/` });

        files.forEach((file) => {
            file = file.replace(`wp-content/themes/${conf.name}/`, '');

            let str = file.replace(/-[a-z0-9]+/, (conf.isProduction ? '(-[a-z0-9]+)?' : ''));

            if (conf.isProduction) {
                stream = stream
                    .pipe(replace(new RegExp(str, 'g'), file));
            } else {
                stream = stream
                    .pipe(replace(new RegExp(file, 'g'), str));
            }
        });

        stream = stream
            .pipe(gulp.dest(`wp-content/themes/${conf.name}/`));

        return stream;
    });
}
