<?php

/**
 * Provide a public-facing view for the plugin
 *
 * This file is used to markup the public-facing aspects of the plugin.
 *
 * @link       https://www.biuro.lt
 * @since      1.0.0
 *
 * @package    Biuro_Contacts
 * @subpackage Biuro_Contacts/public/partials
 */

/**
 * @link https://codex.wordpress.org/Creating_Options_Pages
 * @link https://www.smashingmagazine.com/2016/04/three-approaches-to-adding-configurable-fields-to-your-plugin/
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) die;
?>
    <div class="c-form--row">
        <label class="c-form--label" for="form-city"><?php _e('City', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap c-form--autocomplete">
            <datalist id="form-cities">
<?php
            $cities = get_terms( array(
                'taxonomy' => 'city',
                'hide_empty' => false,
            ) );

            foreach ( $cities as $city ):
?>
                <option value="<?php echo preg_replace('/\D/', '', $city->slug); ?>"><?php echo $city->name; ?></option>
<?php
            endforeach;
?>
            </datalist>
            <input list="form-cities" type="text" class="c-form--input" id="form-city" name="city" value="">
            <input type="hidden" id="form-city-id" name="city_id" value="">
        </div>
    </div>

    <div class="c-form--row">
        <label class="c-form--label" for="form-message"><?php _e('Message', 'biuro-contacts'); ?></label>
        <div class="c-form--textarea-wrap">
            <textarea name="message" id="form-message" cols="30" rows="3" class="c-form--textarea" placeholder="<?php _e("For example: I'm looking for a job in manufacturing", 'biuro-contacts'); ?>"></textarea>
        </div>
    </div>

    <div class="c-form--row">
        <div class="c-form--input-file-wrap">
            <input type="file" class="js-form--input-file c-form--input-file" id="form-cv" name="cv" accept="application/pdf, application/doc, application/docx, application/rtf, application/txt, application/odf, application/msword, image/jpg, image/jpeg, image/png">
            <button class="c-form--input-file-btn">
                <svg width="16px" height="21px" class="c-ico--attachment">
                    <use xlink:href="#ico--attachment"></use>
                </svg>
                <span class="js-form--input-file-text c-form--input-file-text"><?php _e('CV', 'biuro-contacts'); ?></span>
            </button>
        </div>
    </div>

    <div class="c-form--row">
        <div class="c-form--submit-wrap">
            <button type="submit" class="o-btn c-btn--main c-btn--fill" name="s" value="2"><?php _e('Submit', 'biuro-contacts'); ?></button>
        </div>
    </div>

    <div class="c-form--label-recaptcha">
        <?php _e('This site is protected by reCAPTCHA and the Google <a href="https://policies.google.com/privacy">Privacy Policy</a> and <a href="https://policies.google.com/terms">Terms of Service</a> apply.', 'biuro-contacts'); ?>
    </div>
