<?php
/**
 * Template Name: Employees Landing Page III
 *
 * The employees landing page template file
 * Learn more: https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

    get_header('langing');
?>

<div class="l-section l-section--landing-3">
    <div class="l-section--inner">
<?php
        while ( have_posts() ) :
?>
        <div class="c-heading--landing-3">
<?php
            the_post();
            the_content();
?>
        </div>
<?php
        endwhile;
?>
    </div>
</div>

<div id="content">
    <main id="main" class="l-main">

        <div class="c-contact-landing-3">
            <div class="c-contact-landing-3--inner">

                <div class="c-contact-landing-3--content">
                    <?php
                        if ( is_active_sidebar( 'landing_page_employees_3' ) ) :
                            dynamic_sidebar( 'landing_page_employees_3' );
                        endif;
                     ?>

                    <div class="c-contact-landing-3--aside">
                        <svg width="44" height="44" xmlns="http://www.w3.org/2000/svg">
                            <circle fill="#6CCDBC" cx="22" cy="22" r="22"/>
                            <path d="M31.268 13.198l-1.466-1.466A2.49 2.49 0 0028.035 11c-.64 0-1.28.244-1.768.732L12.502 25.497l-.496 4.462a.938.938 0 001.035 1.035l4.458-.492 13.769-13.77a2.5 2.5 0 000-3.534zm-14.343 16.11l-3.634.403.405-3.64 10.308-10.308 3.233 3.233-10.312 10.312zm13.459-13.459l-2.263 2.263-3.233-3.233 2.263-2.263c.236-.236.55-.366.884-.366.334 0 .647.13.884.366l1.465 1.465c.487.488.487 1.28 0 1.768z" fill="#FFF"/>
                        </svg>
                        <p><?php _e('Fill out the inquiry form and we will get back to you within 2 business days!', 'biuro'); ?></p>
                    </div>
                </div>

                <div class="c-contact-landing-3--form">
                    <?php
                        echo do_shortcode('[biuro-contacts--employees page="landing-3"]');
                    ?>
                </div>

            </div><!-- .c-contact-landing-3--inner -->

            <?php
                if ( is_active_sidebar( 'landing_page_jobs_3' ) ) :
                    dynamic_sidebar( 'landing_page_jobs_3' );
                endif;
             ?>
        </div><!-- .c-contact-landing-3 -->

        <?php
            if ( is_active_sidebar( 'front_page_feedbacks' ) ) :
                dynamic_sidebar( 'front_page_feedbacks' );
            endif;
         ?>

    </main><!-- .l-main -->
</div><!-- #content -->

<?php get_footer();
