<!DOCTYPE html>
<html <?php language_attributes(); ?> class="no-js">
<head>
    <meta charset="<?php bloginfo( 'charset' ); ?>">
    <meta content="IE=edge" http-equiv="X-UA-Compatible" />
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title><?php wp_title(''); ?> | Biuro</title>
    <link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <link rel="manifest" href="/site.webmanifest">
    <link rel="mask-icon" href="/safari-pinned-tab.svg" color="#006957">
    <meta name="msapplication-TileColor" content="#ffffff">
    <meta name="theme-color" content="#ffffff">

    <meta name="google-site-verification" content="Xlpzg6WVpXXrivwjXrOaEzjxZQcPP2x0oCoUizYyCDM" />

    <link rel="profile" href="http://gmpg.org/xfn/11">
    <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">

<?php
    if (is_search() || get_post_type() == 'page'):
        get_template_part( 'template-parts/meta/canonical');
    endif;
?>

    <link rel="preload" as="font" type="font/woff2" href="/wp-content/themes/biuro/fonts/roboto-v19-cyrillic_latin_cyrillic-ext_latin-ext-500.woff2" crossorigin="anonymous" >
    <link rel="preload" as="font" type="font/woff2" href="/wp-content/themes/biuro/fonts/roboto-v19-cyrillic_latin_cyrillic-ext_latin-ext-regular.woff2" crossorigin="anonymous" >

    <style><?php include 'css/core-d506648a18.min.css'; ?></style>

    <script>
        document.documentElement.classList.replace('no-js', 'js');
    </script>

    <link rel="preload" as="font" type="font/woff2" href="/wp-content/themes/biuro/fonts/roboto-v19-cyrillic_latin_cyrillic-ext_latin-ext-300.woff2" crossorigin="anonymous" >
    <link rel="preload" as="font" type="font/woff2" href="/wp-content/themes/biuro/fonts/roboto-v19-cyrillic_latin_cyrillic-ext_latin-ext-700.woff2" crossorigin="anonymous" >

    <link rel="preload" href="/wp-content/themes/biuro/css/main-15517d2ff4.min.css" as="style" onload="this.rel='stylesheet'">

    <link rel="preconnect" href="https://www.gstatic.com">
    <link rel="preconnect" href="https://fonts.gstatic.com">

    <noscript>
        <link rel="stylesheet" href="/wp-content/themes/biuro/css/main-15517d2ff4.min.css">
    </noscript>

    <?php wp_head(); ?>
</head>
<body>
    <?php include 'template-parts/svg/icons.php';  ?>

    <header class="l-header">
        <div class="l-inner l-inner--header">

            <a href="<?php echo pll_home_url(); ?>" class="c-logo" title="<?php echo get_the_title( get_option('page_on_front') ); ?>" aria-label="<?php echo get_the_title( get_option('page_on_front') ); ?>">
                <svg width="82px" height="49px" class="c-logo--svg">
                    <use href="#biuro-logo"></use>
                </svg>
            </a>

            <span class="js-toggle--nav l-nav--open">
                <svg width="32px" height="16px">
                    <use href="#ico--burger"></use>
                </svg>
            </span>

            <div class="l-nav--wrap">
                <nav class="l-nav">
    <?php
                    get_template_part( 'template-parts/menus/menu', 'main' );
    ?>
                </nav>
<?php
                $blogID = get_current_blog_id();
                $inEmployers = (is_page() && get_post_meta( $post->ID, 'section', true) == 'employers') ? true : false;

                $phone = '+37064902392';
                $phoneUI = '+370 649 02392';

                if ($blogID == 1 && $inEmployers):
                    $phone = '+37065553216';
                    $phoneUI = '+370 655 53216';
                endif;

                if ($blogID == 2):
                    $phone = '+37166100328';
                    $phoneUI = '+371 661 00328';
                endif;

                if ($blogID == 3):
                    $phone = '+3726108028';
                    $phoneUI = '+372 610  8028';
                endif;
?>
                <a href="tel:<?php echo $phone; ?>" class="c-phone">
                    <svg width="21px" height="22px">
                        <use href="#ico--phone"></use>
                    </svg> <?php echo $phoneUI; ?>
                </a>
<?php
            global $post;

            if ( $inEmployers ):
                $contactsPage = new WP_Query( array(
                    'numberposts'   => 1,
                    'post_type'     => 'page',
                    'meta_key'      => 'page',
                    'meta_value'    => 'employers-contacts'
                ) );

                if ( $contactsPage->have_posts() ) :
                    while( $contactsPage->have_posts() ) :
                        $contactsPage->the_post();
                ?>
                        <a href="<?php echo get_the_permalink(); ?>#action" class="o-btn c-btn--main c-btn--header"><?php _e('Get an offer', 'biuro'); ?></a>
                <?php
                    endwhile;
                endif;
                wp_reset_query();

            else:
                $contactsPage = new WP_Query( array(
                    'numberposts'   => 1,
                    'post_type'     => 'page',
                    'meta_key'      => 'page',
                    'meta_value'    => 'employees-contacts'
                ) );

                if ( $contactsPage->have_posts() ) :
                    while( $contactsPage->have_posts() ) :
                        $contactsPage->the_post();
                ?>
                        <a href="<?php echo get_the_permalink(); ?>#action" class="o-btn c-btn--main c-btn--header"><?php _e('Get a job offer', 'biuro'); ?></a>
                <?php
                    endwhile;
                endif;
                wp_reset_query();

            endif;
 ?>
                <div class="c-nav--lang-wrap">
<?php
                get_template_part( 'template-parts/menus/menu', 'language' );
?>
                </div>

                <span class="js-toggle--nav l-nav--close">
                    <svg width="13px" height="13px">
                        <use href="#ico--close"></use>
                    </svg>
                </span>

            </div>
        </div>
    </header>
